#ifndef __IO_FUNCS_H__
#define __IO_FUNCS_H__

#include "misc.h"

static inline void delay(int n) {
    volatile register int i=0;
    while (i<n)
        i++;
}

// todo, add fns for
//   vppcontrol=0x00
//   vppcontrol=0x07
//   vppcontrol=0xf0
//   watchdog=0xfe
//
//   lptval=0xf0, uartval=0x01
struct bfffff_values {
    char beep_value;
    char uart_value;
    char lpt_value;
};
extern struct bfffff_values bfffff;


static inline void update_bfffff()
{
#ifndef TEST
    *(volatile char*)0xbfffff = bfffff.beep_value|bfffff.uart_value|bfffff.lpt_value;
#endif
}
static inline void bfffff_init()
{
    bfffff.beep_value=0;
    bfffff.uart_value=1;
    bfffff.lpt_value=0xf0;
    update_bfffff();
}
static inline void watchdog()
{
#ifndef TEST
    *(volatile char*)0xbffff3 = 0x80;
    *(volatile char*)0xbffff3 = 0x00;
#endif
}
static inline void wdelay(int n) {
    volatile register int i=0;
    while (i<n) {
        watchdog();
        i++;
    }
}

static inline void set_beep(char on) {
    bfffff.beep_value= on ? 4 : 0;
    update_bfffff();
}
static inline void beep(int n) {
    set_beep(1);
    delay(n);
    set_beep(0);
}
static inline void wbeep(int n) {
    set_beep(1);
    wdelay(n);
    set_beep(0);
}

#ifndef TEST
static inline void clear_bffff5()
{
    *(volatile char*)0xbffff5 = 0;
}
static inline void clear_bc0009()
{
    *(volatile char*)0xbc0009 = 0;
}
#endif
static inline void init_nedap()
{
#ifndef TEST
    short *ptr=(short*)0x404000;
    while (ptr<(short*)0x407000)
        *ptr++ = 0;

    watchdog();
    clear_bffff5();
    watchdog();
    bfffff_init();
    watchdog();
    wbeep(3000);
    watchdog();
    clear_bc0009();     // makes paper feed
    watchdog();

    enable_irqs();
#endif
}
#endif
